src/k9/routes/web.php
<?php

use App\Http\Controllers\Auth\NewPasswordController;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\ApprentiController;
use App\Http\Controllers\BackendController;
use App\Http\Controllers\OffreController;
use App\Http\Controllers\EntrepriseController;
use App\Http\Controllers\UserController;
use App\Http\Controllers\AptitudeController;
use App\Http\Controllers\BulletinController;
use App\Http\Controllers\OptionController;
use App\Http\Controllers\PromotionController;
use App\Http\Controllers\PromotionEleveController;
use App\Http\Controllers\EntretienController;
use App\Http\Controllers\ProfesseurController;
use App\Http\Controllers\FicheController;
use App\Http\Controllers\MatiereController;
use App\Http\Controllers\NoteController;
use App\Http\Controllers\OffreEntreprise;
use App\Http\Controllers\PeriodeController;
use App\Http\Controllers\RdController;
use App\Http\Controllers\TuteurController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/first-password/{token}', [NewPasswordController::class, 'first'])->name('password.first');
    
// Groupe de routes avec uniquement le middleware d'authentification (connecté au site) //
Route::middleware(['auth', 'firstlogin'])->group(function () {
    Route::get('/mentions', [BackendController::class, 'mentions'])->name('mentions');
    Route::get('/', [OffreController::class, 'welcome'])->name('welcome');
    Route::get('profil', [UserController::class, 'profil'])->name('profil');
    Route::post('profil', [UserController::class, 'profilUpdate'])->name('profilUpdate');
    Route::resource('offre_entreprise', OffreEntreprise::class);
});
// Groupe de routes pour les professeurs avec middelware
Route::middleware(['auth', 'firstlogin', 'professeur'])->prefix('professeur')->group(function () {
    Route::get('/', [BackendController::class, 'profDashboard'])->name('profdashboard');
    Route::get('/matiereProfesseur', [MatiereController::class, 'matiereProfesseur'])->name('matiereProfesseur');
    Route::get('/promotionProfesseur', [PromotionController::class, 'promotionProfesseur'])->name('promotionProfesseur');
    Route::resource('notes', NoteController::class)->except(['show']);
    Route::get('notes/create/matieres/{promotion_id}', [NoteController::class, 'createMatieres'])->name('notes.create.matieres');
    Route::get('notes/create/apprentis/{promotion_id}', [NoteController::class, 'createApprentis'])->name('notes.create.apprentis');
    Route::get('notes/create/periodes/{promotion_id}', [NoteController::class, 'createPeriodes'])->name('notes.create.periodes');
});
// Groupe de routes avec le middleware d'authentification et celui d'admin du site //
Route::middleware(['auth','admin', 'firstlogin'])->group(function () {
    Route::get('fiche/pdf', [FicheController::class, 'testViewPDF'])->name('testViewPDF');
    Route::get('fiche/export/{id}', [FicheController::class, 'getPostPdf'])->name('getPostPdf');
    Route::post('/tuteur_entreprise', [OffreController::class, 'tuteurEntreprise'])->name('tuteur_entreprise');
    Route::post('/download', [BackendController::class, 'download'])->name('download');
    Route::post('/contact', [BackendController::class, 'contact'])->name('contact');
    /* Changer ces routes dans le rd */
    Route::post('/promotionPeriode', [PeriodeController::class, 'promotionPeriode'])->name('promotionPeriode');
    Route::post('/promotionApprenti', [PromotionController::class, 'promotionApprenti'])->name('promotionApprenti');
    Route::get('/bulletinPromotion', [BulletinController::class, 'bulletinPromotion'])->name('bulletinPromotion');
    Route::post('/bulletinMatiere', [BulletinController::class, 'bulletinMatiere'])->name('bulletinMatiere');
    Route::post('/promotionMatiere',[PromotionController::class, 'promotionMatiere'])->name('promotionMatiere');
    /* */
    Route::prefix('admin')->group(function () {
        Route::resource('aptitudes', AptitudeController::class);
        Route::resource('offres', OffreController::class);
        Route::resource('entreprises', EntrepriseController::class);
        Route::resource('tuteurs', TuteurController::class);
        Route::resource('users', UserController::class);
        Route::resource('options', OptionController::class);
        Route::resource('promotions', PromotionController::class);
        Route::resource('apprenti', ApprentiController::class);
        Route::resource('eleve_promotion', PromotionEleveController::class);
        Route::resource('entretiens', EntretienController::class);
        Route::resource('professeur', ProfesseurController::class);
        Route::resource('fiches', FicheController::class);
        Route::resource('rd', RdController::class);
        Route::resource('matieres',MatiereController::class);
        Route::resource('periodes',PeriodeController::class);
        // A changer dans rd
        Route::resource('bulletins',BulletinController::class);
        Route::get('/', [BackendController::class, 'dashboard'])->name('dashboard');
    });
});
require __DIR__ . '/auth.php';

src/k9/app/Models/Promotion.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Promotion extends Model
{


    protected $fillable = ['id','rd_id', 'libelle','date_debut','date_fin'];

    public function professeurs()
    {
      return $this->belongsToMany(Professeur::class);
    }

    public function apprentis()
    {
      return $this->hasMany(Apprenti::class);
    }

    public function periodes()
    {
      return $this->BelongsToMany(Periode::class);
    }

    public function options()
    {
      return $this->BelongsToMany(Option::class);
  }

  public function matieres()
  {
    return $this->BelongsToMany(Matiere::class)->withPivot('coef');
  }

  public function rd()
  {
    return $this->BelongsTo(Rd::class);
  }

    use HasFactory;

}
//des eleves - un prof - des options 

src/k9/app/Http/Controllers/PromotionController.php
<?php

namespace App\Http\Controllers;

use Exception;
use App\Models\{Promotion, Professeur, Rd,Apprenti,Matiere};
use Illuminate\Http\Request;

class PromotionController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $promotions = Promotion::get()->all();
        return view('promotions.index', compact('promotions'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $rds = Rd::all();
        return view('promotions.edit', compact('rds'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
      $data = request()->validate([
        'libelle'=>'required',
        'date_debut' => 'required',
        'date_fin' => 'required|after:date_debut',
        'rd_id'=>'required',
      ]);
        Promotion::create($data);
        return redirect()->route('promotions.index')->with('success', 'Promotion créée');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function show(Promotion $promotion)
    {
      return view('promotions.show', compact('promotion'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function edit(Promotion $promotion)
    {
      $rds = Rd::all();
      return view('promotions.edit', compact('rds', 'promotion'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Promotion $promotion)
    {
      $request->validate([
        'libelle' => 'required',
        'date_debut' => 'required',
        'date_fin' => 'required|after:date_debut',
        'rd_id' => 'required',
      ]);
      $promotion->update($request->all());
      return redirect()->route('promotions.index')->with('success', 'Promotion modifiée');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Promotion  $promotion
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
      try {
        $promotion = Promotion::find($id);
        $promotion->delete();
        return redirect()->route('promotions.index')->with('success', 'Promotion supprimée');
      } catch (Exception $e){
        $msg = "";
          switch ($e->getCode()) {
            case 23000:
                $msg ="l'élément ne peut etre supprimés car il est lié à un autre élément";
                break;
            default:
                $msg = $e->getMessage();
                break;
          }
          return redirect()->back()->withErrors($msg);
      }
    }

    public function promotionProfesseur() {
      $user = auth()->user();
      $promotions = Promotion::whereRelation('professeurs', 'professeur_id','=', $user->profil_id)->get();
      return view('professeur_dashboard.promotions', compact('promotions'));
    }

    public function promotionApprenti(Request $request) {
      $id = $request->get('id');
      $apprentis = Apprenti::with('user')->where('promotion_id','=',$id)->get();
      return response()->json($apprentis);
    }

    public function promotionMatiere(Request $request) {
      $id = $request->get('id');
      $matieres = Matiere::whereRelation('promotions', 'promotion_id','=', $id)->get();
      return response()->json($matieres);
    }

}

src/k9/resources/views/Promotions/edit.blade.php
@extends('backend.template')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>{{ !empty($promotion) ? 'Modifier' : 'Créer' }} une promotion</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-primary" href="{{ route('promotions.index') }}">Retour</a>
            </div>
        </div>
    </div>

    @if ($errors->any())
        <div class="alert alert-danger">
            Une erreur est survenue..<br>
            <ul>
                @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                @endforeach
            </ul>
        </div>
    @endif

    @isset($promotion)
        <form action="{{ route('promotions.update', $promotion) }}" method="POST">
            @method('PUT')
        @else
            <form action="{{ route('promotions.store') }}" method="POST">
            @endisset
            @csrf
            <div class="container">
                <div class="row">
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Libelle :</a>
                            <input type="text" name="libelle" class="form-control" placeholder="SIO"
                                value="{{ !empty($promotion) ? $promotion->libelle : old('libelle') }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                          <a class="font-bold">Date de début de la promotion :</a>
                          <input type="date" name="date_debut" class="form-control" value="{{ !empty($promotion) ? $promotion->date_debut : (empty(old('date_debut')) ? Carbon\Carbon::now()->format('Y-m-d') : old('date_debut')) }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                          <a class="font-bold">Date de fin de la promotion :</a>
                          <input type="date" name="date_fin" class="form-control" value="{{ !empty($promotion) ? $promotion->date_fin : (empty(old('date_fin')) ? Carbon\Carbon::now()->format('Y-m-d') : old('date_fin')) }}">
                        </div>
                    </div>
                    <div class="col-12">
                        <div class="form-group">
                            <a class="font-bold">Responsable de dispositif :</a>
                            <select class="form-select" name="rd_id" id="rd_id">
                                @foreach ($rds as $rd)
                                    <option value="{{ $rd->id }}"
                                        {{ !empty($promotion) ? ($promotion->rd->id == $rd->id ? 'selected' : '') : '' }}>
                                        {{ $rd->user->nom .' '.$rd->user->prenom }}</option>
                                @endforeach
                            </select>
                        </div>
                    </div>
                    <div class="col-12 text-center">
                        <button type="submit" class="btn btn-primary">Enregistrer</button>
                    </div>
                </div>
            </div>
        </form>
    @endsection

src/k9/resources/views/Promotions/index.blade.php
@extends('backend.template')

@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>CRUD Promotions</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-success" href="{{ route('promotions.create') }}"> Créer une Promotion</a>
            </div>
        </div>
    </div>

    @if ($message = Session::get('success'))
        <div class="alert alert-success">
            <p>{{ $message }}</p>
        </div>
    @elseif($errors->any())
        <div class="alert alert-warning">
            {{$errors->first()}}
        </div>
    @endif

    <div class="padd20">
        <table class="table table-bordered" id="example">
            <thead>
                <th>ID</th>
                <th>Libelle</th>
                <th>Responsable de dispositif</th>
                <th>Date de début</th>
                <th>Date de fin</th>
                <th width="280px">Action</th>
            </thead>
            <tbody>
            @foreach ($promotions as $p)
                <tr>
                    <td>{{ $p->id }}</td>
                    <td>{{ $p->libelle }}</td>
                    <td>{{ $p->rd->user->nom . ' ' . $p->rd->user->prenom }}</td>
                    <td>{{\Carbon\Carbon::parse($p->date_debut)->format('d/m/Y')}}</td>
                    <td>{{\Carbon\Carbon::parse($p->date_fin)->format('d/m/Y')}}</td>
                    <td class="actions">
                        <a class="btn btn-edit col" href="{{ route('promotions.edit', $p) }}"></a>
                        <a class="btn btn-show col" href="{{ route('promotions.show', $p) }}"></a>
                    
                            <!-- Button trigger modal -->
                        <button type="button" class="btn btn-delete col" data-bs-toggle="modal" data-bs-target="#{{ "modal-".$p->id}}"></button>
                        
                        <form action="{{ route('promotions.destroy',$p) }}" method="POST" >
                            @csrf
                            @method('DELETE')
                            <!-- Modal Suppression-->
                            <div class="modal fade" id="{{ "modal-".$p->id}}" tabindex="-1" aria-labelledby="{{ "modalLabel-".$p->id}}" aria-hidden="true">
                                <div class="modal-dialog">
                                    <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="{{ "modalLabel-".$p->id}}">
                                            Supression Promotion</h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                                    </div>
                                    <div class="modal-body">
                                        Voulez-vous vraiment supprimer cette promotion?
                                    </div>
                                    <div class="modal-footer">
                                        <button type="button" class="btn-modal btn-secondary" data-bs-dismiss="modal">Fermer</button>
                                        <button type="submit" class="btn-modal btn-primary">Supprimer</button>
                                    </div>
                                    </div>
                                </div>
                            </div>
                        </form>
                    </td>
                </tr>
            @endforeach
            </tbody>
        </table>
    </div>
@endsection

src/k9/resources/views/Promotions/show.blade.php
@extends('backend.template')
  
@section('content')
    <div class="row">
        <div class="col-lg-12 margin-tb">
            <div class="float-start">
                <h2>Promotion</h2>
            </div>
            <div class="float-end">
                <a class="btn btn-outline-primary" href="{{ route('promotions.index') }}">Retour</a>
            </div>
        </div>
    </div>
   
    <div class="row">
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <a class="font-bold">Libelle :</a>
                {{ $promotion->libelle }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <a class="font-bold">Date de début de la promotion :</a>
                {{ $promotion->date_debut }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <a class="font-bold">Date de fin de la promotion :</a>
                {{ $promotion->date_fin }}
            </div>
        </div>
        <div class="col-xs-12 col-sm-12 col-md-12">
            <div class="form-group">
                <a class="font-bold">Responsable de dispositif :</a>
                {{ $promotion->rd->user->prenom.' '.$promotion->rd->user->nom }}
            </div>
        </div>
    </div>
@endsection     